#include <linux/slab.h>
#include <linux/types.h>
#include <linux/mutex.h>
#include <linux/kernel.h>
#include <linux/module.h>

#include "syswall.h"

#include "hash.h"

int hashcreate(struct hashmap_t *hm, int hm_size, int element_size, void *alloc)
{
	if (!hm)
		return 0;

    hm->hm = 0;
    if (!hm_size)
    	hm->hm_size = HASHMAP_SIZE;
    else
    	hm->hm_size = hm_size;

    hm->element_size = element_size;

    if (alloc)
    	hm->hm = alloc;
    else
		hm->hm = kmalloc(hm->hm_size * hm->element_size, GFP_KERNEL);    	

    if (hm->hm)
    	memset(hm->hm, 0, hm->hm_size * hm->element_size);

    //printk("hm_size = %d\n", hm->hm_size);
    //printk("hm_element_size = %d\n", hm->element_size);
    //printk("hm_hm = %#x\n", hm->hm);

    hm->hot = 0;
    hm->vma = (hm->hm + (hm->hm_size * hm->element_size));
    hm->vma_num = 0;

    // debug only
    //printk("hm->hm = %#x - %#x  hm->vma = %#x - %#x  hm = %#x - %#x\n", hm->hm, hm->hm + (hm->hm_size * hm->element_size), hm->vma, 0, hm, ((unsigned int)hm) + (4096*6));

    return 1;
}

unsigned int hashget(struct hashmap_t *hm, unsigned int k)
{
    unsigned int p = (k >> 2) % hm->hm_size;

    if (p >= hm->hm_size) {
    	printk("BUUUG 2  = p = %#x\n", p);
    	return 0;
    }

    return p;
}

/*
void hashfree(unsigned int *h, const unsigned int bounds)
{
	int i;
#ifdef HASH_STATS
	int used = 0;
	int subused = 0;
#endif


	if (!h)
		return;

	printk("h = %#x\n", h);

	for (i = 0; i < HASHMAP_SIZE; i++) {
		if (h[i] > bounds) {
			//kfree(h[i]);
			printk("%d > B  h[i] = %x\n", i, h[i]);
#ifdef HASH_STATS
			subused++;
#endif
		}
#ifdef HASH_STATS
		else if (h[i] != 0) {
			printk("%d != 0 h[i] = %x\n", i, h[i]);
			used++;
		}
#endif
	}

	//kfree(h);
#ifdef HASH_STATS
	DPRINT("hashmap stats syscall buckets: %d vet buckets: %d\n", used, subused);
#endif

	return;
}
*/