/*
  *  BINtegrity aka Syswall
 *
 */

#ifndef __SYSWALL_ARM_H__
#define __SYSWALL_ARM_H__

void hook_arm_sys_wrapper(char *name, char *rname, unsigned char *check);

#define HOOK(name) ref_sys_##name = (void *)sys_call_table[__NR_##name]; sys_call_table[__NR_##name] = (void *)sc_hook_##name;
#define UNHOOK(name) sys_call_table[__NR_##name] = (unsigned *)ref_sys_##name;

#define HOOK2(name) hook_arm_sys_wrapper("sys_"#name"_wrapper", "sys_"#name, (char*)sc_hook_##name);

#define KERNEL_BOUNDARY 0xc0000000

#define ELF_READ_SIZE 1024*1024

#define LINKER "linker"
#define LINKER_LEN 5

#define SYSCALL_HOOK_EXIT(name) \
    asmlinkage unsigned (*ref_sys_##name)(); \
    extern void asmlinkage sc_hook_##name(); \
    void sc_hook_##name##_c() { \
        __asm__ (".globl sc_hook_" #name        "\n" \
                "sc_hook_" #name ":"          "\n" \
                "sub sp,sp,#24\n"\
                "push {fp, lr}\n"\
                "push {r0, r1, r2, r3}\n"\
                "add r0,sp,#52\n"\
                "ldr r7, ldtest" #name "\n"\
                "blx r7 \n"\
                "pop {r0,r1,r2,r3}\n"\
                "pop {fp, lr}\n"\
                "add sp,sp,#24\n"\
                "ldr r7, ldref" #name "\n"\
                "ldr pc, [r7]\n"\
                "ldtest" #name ":\n"\
                ".word check_exit\n"\
                "ldref" #name ":\n"\
                ".word ref_sys_" #name "\n"\
                ); \
    }

#define SYSCALL_HOOK(name, level) \
    asmlinkage unsigned (*ref_sys_##name)(); \
    extern void asmlinkage sc_hook_##name(); \
    void sc_hook_##name##_c() { \
        __asm__ (".globl sc_hook_" #name        "\n" \
                "sc_hook_" #name ":"          "\n" \
                "sub sp,sp,#24\n"\
                "push {fp, lr}\n"\
                "push {r0, r1, r2, r3}\n"\
                "add r0,sp,#52\n"\
                "ldr r7, ldtest" #name "\n"\
                "blx r7 \n"\
                "pop {r0,r1,r2,r3}\n"\
                "pop {fp, lr}\n"\
                "add sp,sp,#24\n"\
                "ldr r7, ldref" #name "\n"\
                "ldr pc, [r7]\n"\
                "ldtest" #name ":\n"\
                ".word check_syscall_" #level "\n"\
                "ldref" #name ":\n"\
                ".word ref_sys_" #name "\n"\
                ); \
    }

#define SYSCALL_HOOK2(name, level) \
    asmlinkage unsigned (*ref_sys_##name)(); \
    extern void sc_hook_##name(); \
    void sc_hook_##name##_c() { \
        __asm__ (".globl sc_hook_" #name        "\n" \
                "sc_hook_" #name ":"          "\n" \
                "sub sp,sp,#20\n"\
                "push {lr}\n"\
                "push {r0, r1, r2, r3}\n"\
                "add r0, sp, #48\n"\
                "ldr r7, ldchecksyscall" #name "\n"\
                "blx r7\n"\
                "pop {r0, r1, r2, r3}\n"\
                "pop {lr}\n"\
                "add sp, sp, #20\n"\
                "mov r0,r0\n"\
                "mov r0,r0\n"\
                "mov r0,r0\n"\
                "mov r0,r0\n"\
                "mov r0,r0\n"\
                "mov r0,r0\n"\
                "ldchecksyscall" #name ":\n"\
                ".word check_syscall_" #level "\n"\
                "wrapper" #name ":\n"\
                "ldr pc, ldhook" #name "\n"\
                "ldhook" #name ":\n"\
                ".word sc_hook_" #name "\n"\
                ); \
    }

#include "hooks.h"

#endif
